\NeedsTeXFormat{LaTeX2e}
\RequirePackage{expl3}
\ProvidesExplClass{iNSFC-ng}
  {2021-07-09}{v0.1a}{NSFC template}
\RequirePackage { xparse, l3keys2e }
\cs_generate_variant:Nn \cs_generate_variant:Nn { cn }
\cs_generate_variant:Nn \file_input:n           { V  }
\cs_generate_variant:Nn \int_to_arabic:n        { v  }
\cs_generate_variant:Nn \keys_define:nn         { nx }
\cs_generate_variant:Nn \tl_map_inline:nn       { xn }
\prg_generate_conditional_variant:Nnn \tl_if_eq:nn { Vn } { T, TF }
\cs_new:Npn \__fdu_msg_new:nn  { \msg_new:nnn      { fduthesis } }
\cs_new:Npn \__fdu_error:n     { \msg_error:nn     { fduthesis } }
\cs_new:Npn \__fdu_error:nn    { \msg_error:nnn    { fduthesis } }
\cs_new:Npn \__fdu_error:nx    { \msg_error:nnx    { fduthesis } }
\cs_new:Npn \__fdu_error:nnn   { \msg_error:nnnn   { fduthesis } }
\cs_new:Npn \__fdu_warning:n   { \msg_warning:nn   { fduthesis } }
\cs_new:Npn \__fdu_warning:nn  { \msg_warning:nnn  { fduthesis } }
\cs_new:Npn \__fdu_warning:nxx { \msg_warning:nnxx { fduthesis } }
\cs_new:Npn \__fdu_info:nx     { \msg_info:nnx     { fduthesis } }
\fp_const:Nn \c__fdu_line_spread_fp
  { \dim_ratio:nn { 19 pt } { 12 bp } / 1.2 }
\PassOptionsToClass
  {
    UTF8,
    heading    = true,
    fontset    = none,
    zihao      = -4,
    linespread = \c__fdu_line_spread_fp,
  }
  { ctexart }
\RequirePackage { etoolbox }
\LoadClass { ctexart }
\RequirePackage
  {
    amsmath,
    geometry,
    graphicx,
    caption,
    subfig,
    xcolor,
    hyperref,
  }
\geometry
  {
    paper      = a4paper,
    vmargin    = 2.5 cm,
    hmargin    = 3 cm,
  }
\tl_new:N \g__fdu_fontset_tl
\keys_define:nn { fdu / style }
  {
    font .choices:nn =
      { times, times*, none }
      { \tl_set_eq:NN \g__fdu_fontset_tl \l_keys_choice_tl }
  }
\tl_new:N \g__fdu_cjk_fontset_tl
\keys_define:nn { fdu / style }
  {
    cjk-font .choices:nn =
      { fandol, mac, windows, none }
      { \tl_set_eq:NN \g__fdu_cjk_fontset_tl \l_keys_choice_tl }
  }
\cs_new_protected:Npn \__fdu_setmainfont:nn #1#2
  { \__fontspec_main_setmainfont:nn {#2} {#1} }
\cs_new_protected:Npn \__fdu_setsansfont:nn #1#2
  { \__fontspec_main_setsansfont:nn {#2} {#1} }
\cs_new_protected:Npn \__fdu_setmonofont:nn #1#2
  { \__fontspec_main_setmonofont:nn {#2} {#1} }
\cs_new_protected:Npn \__fdu_setCJKmainfont:nn #1#2
  { \__fdu_set_family:nnn { \CJKrmdefault } {#2} {#1} }
\cs_new_protected:Npn \__fdu_setCJKsansfont:nn #1#2
  { \__fdu_set_family:nnn { \CJKsfdefault } {#2} {#1} }
\cs_new_protected:Npn \__fdu_setCJKmonofont:nn #1#2
  { \__fdu_set_family:nnn { \CJKttdefault } {#2} {#1} }
\tl_const:Nn \__fdu_cjk_font_options:
 { UprightFont = *, ItalicFont = *, AutoFakeBold = true }
\cs_new_protected:Npx \__fdu_setCJKmainfont:n   #1
  { \__fdu_setCJKmainfont:nn   {#1} { \__fdu_cjk_font_options: } }
\cs_new_protected:Npx \__fdu_setCJKsansfont:n   #1
  { \__fdu_setCJKsansfont:nn   {#1} { \__fdu_cjk_font_options: } }
\cs_new_protected:Npx \__fdu_setCJKmonofont:n   #1
  { \__fdu_setCJKmonofont:nn   {#1} { \__fdu_cjk_font_options: } }
\sys_if_engine_xetex:TF
  {
    \cs_new_eq:NN \__fdu_set_family:nnn  \xeCJK_set_family:nnn
    \cs_new_eq:NN \__fdu_switch_family:n \xeCJK_switch_family:n
  }
  {
    \cs_new_eq:NN \__fdu_set_family:nnn  \ctex_ltj_set_family:nnn
    \cs_new_eq:NN \__fdu_switch_family:n \ctex_ltj_switch_family:n
  }
\cs_new_protected:Npn \__fdu_set_font_helper:n #1
  {
    \exp_args:Nc \RenewDocumentCommand { set #1 font } { O { } m O { } }
      {
        \ctex_at_end_preamble:n
          { \use:c { __fdu_set #1 font:nn } {##2} { ##1, ##3 } }
      }
  }
\clist_map_inline:nn { main, sans, mono          } { \__fdu_set_font_helper:n {#1} }
\clist_map_inline:nn { CJKmain, CJKsans, CJKmono } { \__fdu_set_font_helper:n {#1} }
\cs_new_protected:Npn \__fdu_load_font_times:
  {
    \__fdu_setmainfont:nn { XITS }
      {
        Extension          = .otf,
        UprightFont        = *-Regular,
        BoldFont           = *-Bold,
        ItalicFont         = *-Italic,
        BoldItalicFont     = *-BoldItalic
      }
    \__fdu_setsansfont:nn { texgyreheros }
      {
        Extension      = .otf,
        UprightFont    = *-regular,
        BoldFont       = *-bold,
        ItalicFont     = *-italic,
        BoldItalicFont = *-bolditalic
      }
    \__fdu_setmonofont:nn { texgyrecursor }
      {
        Extension      = .otf,
        UprightFont    = *-regular,
        BoldFont       = *-bold,
        ItalicFont     = *-italic,
        BoldItalicFont = *-bolditalic,
        Ligatures      = CommonOff
      }
  }
\cs_new_protected:cpn { __fdu_load_font_ times* : }
  {
    \__fdu_setmainfont:nn { Times~ New~ Roman    } { }
    \__fdu_setsansfont:nn { Arial                } { }
    \__fdu_setmonofont:nn { Courier~ New         } { }
  }
\cs_new_protected:Npn \__fdu_load_cjk_font_fandol:
  {
    \__fdu_setCJKmainfont:nn   { FandolKai }
      {
        Extension      = .otf,
        UprightFont    = *-Regular,
        AutoFakeBold   = true,
      }
    \__fdu_setCJKsansfont:nn   { FandolHei  }
      {
        Extension      = .otf,
        UprightFont    = *-Regular,
        BoldFont       = *-Bold,
        ItalicFont     = *-Regular,
        BoldItalicFont = *-Bold
      }
    \__fdu_setCJKmonofont:nn   { FandolFang }
      {
        Extension      = .otf,
        UprightFont    = *-Regular,
        BoldFont       = *-Regular,
        ItalicFont     = *-Regular,
        BoldItalicFont = *-Regular
      }
    \newfontfamily\nsfckai{FandolKai}[AutoFakeBold   = true]
  }
\cs_new_protected:Npn \__fdu_load_cjk_font_mac:
  {
    \__fdu_setCJKmainfont:nn   { STKaitiSC }
      {
        UprightFont    = *-Regular,
        BoldFont       = *-Bold,
        ItalicFont     = *-Regular,
        BoldItalicFont = *-Bold
      }
    \__fdu_setCJKsansfont:nn   { STHeitiSC   }
      {
        UprightFont    = *-Medium,
        BoldFont       = *-Medium,
        ItalicFont     = *-Medium,
        BoldItalicFont = *-Medium
      }
    \__fdu_setCJKmonofont:n    { STFangsong  }
    \newfontfamily\nsfckai{STKaitiSC}[AutoFakeBold   = true]
  }
\cs_new_protected:Npn \__fdu_load_cjk_font_windows:
  {
    \__fdu_setCJKmainfont:n   { KaiTi    }
    \__fdu_setCJKsansfont:n   { SimHei   }
    \__fdu_setCJKmonofont:n   { FangSong }
    \newfontfamily\nsfckai{KaiTi}[AutoFakeBold   = true]
  }
\cs_new_protected:Npn \__fdu_load_font:
  {
    \use:c { __fdu_load_font_     \g__fdu_fontset_tl     : }
    \use:c { __fdu_load_cjk_font_ \g__fdu_cjk_fontset_tl : }
  }
\ctex_at_end_preamble:n { \__fdu_load_font: }
\keys_set:nn { ctex }
  {
    section =
      {
        format      = \zihao{3}\bfseries\centering,
        beforeskip  = 0.5\baselineskip,
        afterskip   = 0.5\baselineskip,
        fixskip     = true
      },
  }
\captionsetup [ figure ]
  {
    labelsep = space,
  }
\captionsetup [ table  ]
  {
    labelsep = space,
  }
\captionsetup[subfigure]{font = small}
\bool_new:N \l__fdu_bibtex_bool
\tl_new:N \l__fdu_bib_style_tl
\tl_new:N \l__fdu_bib_gb_style_tl
\tl_new:N \l__fdu_cite_style_tl
\clist_new:N \l__fdu_bib_resource_clist
\keys_define:nn { fdu / style }
  {
    bib-backend .choice:,
    bib-backend .value_required:n = true,
    bib-backend / bibtex   .code:n =
      { \bool_set_true:N  \l__fdu_bibtex_bool },
    bib-backend / biblatex .code:n =
      { \bool_set_false:N \l__fdu_bibtex_bool },
    bib-style .choice:,
    bib-style .value_required:n = true,
    bib-style / numerical    .code:n =
      {
        \tl_set:Nn  \l__fdu_bib_gb_style_tl { numerical  }
        \tl_clear:N \l__fdu_bib_style_tl
      },
    bib-style / author-year .code:n =
      {
        \tl_set:Nn  \l__fdu_bib_gb_style_tl { author-year }
        \tl_clear:N \l__fdu_bib_style_tl
      },
    bib-style / unknown     .code:n =
      { \tl_set_eq:NN \l__fdu_bib_style_tl \l_keys_value_tl },
    cite-style .code:n =
      {
        \bool_if:NTF \l__fdu_bibtex_bool
          { \__fdu_warning:n { cite-style-not-available } }
          { \tl_set:Nn \l__fdu_cite_style_tl {#1} }
      },
    bib-resource .clist_set:N = \l__fdu_bib_resource_clist
  }
\__fdu_msg_new:nn { cite-style-not-available }
  { Option~ "cite-style"~ is~ not~ available~ in~ BibTeX. }
\ctex_at_end_preamble:n
  {
    \bool_if:NT \l__fdu_bibtex_bool
      {
        \RequirePackage [ sort & compress ] { natbib }
        \__fdu_bibtex_setup:
      }
  }
\AddToHook
  { env/document/begin }
  {
    \bool_if:NF \l__fdu_bibtex_bool
      {
        \__fdu_biblatex_pre_setup:
        \RequirePackage { biblatex }
        \__fdu_biblatex_post_setup:
      }
  }
\cs_new_protected:Npn \__fdu_bibtex_setup:
  {
    \tl_if_empty:NTF \l__fdu_bib_style_tl
      {
        \tl_if_eq:VnTF \l__fdu_bib_gb_style_tl { numerical }
          {
%             \bibliographystyle { my.bst }
            \bibliographystyle { gbt7714-numerical }
            \__fdu_set_cite_style_numerical:
          }
          {
            \tl_if_eq:VnT \l__fdu_bib_gb_style_tl { author-year }
              {
                \bibliographystyle { gbt7714-author-year }
                \__fdu_set_cite_style_author_year:
                \cs_set_eq:NN \cite \citep
              }
          }
      }
      { \exp_args:NV \bibliographystyle \l__fdu_bib_style_tl }
    % \cs_set:Npn \bibsection { \section* {\bibname} }
    \NewDocumentCommand \printbibliography { o }
      {
        \exp_args:NV \bibliography \l__fdu_bib_resource_clist
        \IfValueT {##1}
          { \__fdu_warning:nn { invalid-option-in-bibtex } {##1} }
      }
  }
\__fdu_msg_new:nn { invalid-option-in-bibtex }
  { Option(s)~ "#1"~ are~ invalid~ in~ BibTeX. }
\cs_new_protected:Npn \__fdu_biblatex_pre_setup:
  {
    \tl_if_empty:NTF \l__fdu_bib_style_tl
      {
        \tl_if_eq:VnTF \l__fdu_bib_gb_style_tl { numerical }
          { \__fdu_pass_options_to_biblatex:n { style = gb7714-2015 } }
          {
            \tl_if_eq:VnT \l__fdu_bib_gb_style_tl { author-year }
              { \__fdu_pass_options_to_biblatex:n { style = gb7714-2015ay } }
          }
      }
      { \__fdu_pass_options_to_biblatex:n { style = \l__fdu_bib_style_tl } }
    \tl_if_empty:NF \l__fdu_cite_style_tl
      { \__fdu_pass_options_to_biblatex:n { citestyle = \l__fdu_cite_style_tl } }
    \__fdu_pass_options_to_biblatex:n { backend = biber, hyperref = manual, natbib }
  }
\cs_new_protected:Npn \__fdu_biblatex_post_setup:
  {
    \clist_map_function:NN \l__fdu_bib_resource_clist \addbibresource
    \__fdu_biblatex_allow_url_break:
    \defbibheading { bibliography } [ \bibname ] { \section* {##1} }
  }
\cs_new_protected:Npn \__fdu_pass_options_to_biblatex:n #1
  { \PassOptionsToPackage {#1} { biblatex } }
\cs_new:Npn \__fdu_biblatex_allow_url_break:
  {
    \int_set_eq:NN \c@biburlucpenalty  \c_one_int
    \int_set_eq:NN \c@biburlnumpenalty \c_one_int
    \int_set_eq:NN \c@biburllcpenalty  \c_one_int
  }
\cs_new:Npn \__fdu_set_cite_style_numerical:
  {
    \NAT@numberstrue \NAT@supertrue
    \cs_set:Npn \NAT@open  { [  }
    \cs_set:Npn \NAT@close { ]  }
    \cs_set:Npn \NAT@sep   { ,~ }
  }
\cs_new:Npn \__fdu_set_cite_style_author_year:
  {
    \NAT@numbersfalse
    \cs_set_eq:NN \NAT@open  \c__fdu_fwid_left_paren_tl
    \cs_set_eq:NN \NAT@close \c__fdu_fwid_right_paren_tl
    \cs_set_eq:NN \NAT@sep   \c__fdu_fwid_semicolon_tl
    \cs_set_eq:NN \NAT@aysep \c__fdu_fwid_comma_tl
    \cs_set_eq:NN \NAT@yrsep \c__fdu_ideo_comma_tl
  }
\keys_define:nn { fdu }
  {
    style .meta:nn = { fdu / style } {#1}
  }
\keys_set:nn { fdu }
  {
    style   / bib-style       = numerical,
  }
\NewDocumentCommand \fdusetup { m }
  { \keys_set:nn { fdu } {#1} }
\pagestyle{empty}
\setlength{\parskip}{0.5\baselineskip}
\renewcommand{\maketitle}{\begingroup \centering \zihao{3} \bfseries 报告正文\par \endgroup}
\definecolor{iNSFC-ng}{RGB}{0, 112, 192}
\newcounter{NSFCsection}
\setcounter{NSFCsection}{0}
\renewcommand\theNSFCsection{（\chinese{NSFCsection}）}
\newcounter{NSFCsubsection}[NSFCsection]
\setcounter{NSFCsubsection}{0}
\renewcommand\theNSFCsubsection{\arabic{NSFCsubsection}．}
\newcommand{\nsfcsection}[2]{%
  \begingroup%
    \stepcounter{NSFCsection}%
    \nsfckai\zihao{4}\color{iNSFC-ng}%
    {\bfseries\theNSFCsection #1}%
    #2\par%
  \endgroup%
}
\newcommand{\nsfcsubsection}[2]{%
  \begingroup%
    \stepcounter{NSFCsubsection}%
    \nsfckai\zihao{4}\color{iNSFC-ng}%
    \theNSFCsubsection%
    {\bfseries #1}%
    #2\par%
  \endgroup%
}
\endinput
